import{S as wp,i as bp,s as Ep,e as n,k as h,w as m,t as s,M as jp,c as r,d as a,m as c,a as i,x as d,h as o,b as u,G as t,g as p,y as g,L as $p,q as f,o as _,B as v,v as Tp}from"../chunks/vendor-hf-doc-builder.js";import{I as x}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C}from"../chunks/CodeBlock-hf-doc-builder.js";function Ap(Ei){let I,Ua,G,Z,Ct,je,co,zt,uo,Xa,Ze,mo,Ra,ee,go,et,fo,_o,Ka,z,Mt,tt,vo,yo,St,at,ko,wo,Pt,st,bo,Ja,ot,Eo,Qa,te,jo,Lt,$o,To,Va,nt,Ao,Za,M,Dt,xo,qo,Ft,Co,zo,It,Mo,es,O,ae,Gt,$e,So,Ot,Po,ts,S,Lo,rt,Do,Fo,Nt,Io,Go,as,se,Oo,Ht,No,Ho,ss,Te,os,oe,Yo,Yt,Wo,Bo,ns,it,Uo,rs,N,ne,Wt,Ae,Xo,Bt,Ro,is,P,Ko,Ut,Jo,Qo,Xt,Vo,Zo,ls,xe,ps,lt,en,hs,b,pt,Rt,tn,an,sn,ht,Kt,on,nn,rn,re,Jt,ln,pn,Qt,hn,cn,un,ct,Vt,mn,dn,cs,H,ie,Zt,qe,gn,ea,fn,us,ut,_n,ms,E,Ce,vn,mt,yn,kn,wn,ta,bn,En,Y,jn,dt,$n,Tn,aa,An,xn,qn,W,Cn,sa,zn,Mn,oa,Sn,Pn,ds,ze,gs,j,Ln,na,Dn,Fn,gt,In,Gn,ft,On,Nn,fs,Me,_s,B,le,ra,Se,Hn,ia,Yn,vs,y,Wn,la,Bn,Un,pa,Xn,Rn,ha,Kn,Jn,ca,Qn,Vn,ua,Zn,er,ma,tr,ar,da,sr,or,ys,L,nr,_t,rr,ir,ga,lr,pr,ks,Pe,ws,U,pe,fa,Le,hr,_a,cr,bs,$,ur,va,mr,dr,ya,gr,fr,De,_r,vr,Es,vt,yr,js,X,he,ka,Fe,kr,wa,wr,$s,q,ba,br,Er,Ea,jr,$r,ja,Tr,Ar,Ts,Ie,As,R,ce,$a,Ge,xr,Ta,qr,xs,w,Cr,Oe,zr,Mr,Ne,Sr,Pr,Aa,Lr,Dr,xa,Fr,Ir,qs,He,Cs,K,ue,qa,Ye,Gr,Ca,Or,zs,yt,Nr,Ms,me,Hr,za,Yr,Wr,Ss,We,Ps,J,de,Ma,Be,Br,Sa,Ur,Ls,kt,Xr,Ds,ge,Rr,Pa,Kr,Jr,Fs,Ue,Is,Q,fe,La,Xe,Qr,Da,Vr,Gs,D,Zr,Fa,ei,ti,Ia,ai,si,Os,Re,Ns,V,_e,Ga,Ke,oi,Oa,ni,Hs,T,ri,Je,ii,li,Na,pi,hi,Ha,ci,ui,Ys,Qe,Ws,A,mi,Ya,di,gi,Wa,fi,_i,wt,vi,yi,Bs;return je=new x({}),$e=new x({}),Te=new C({props:{code:`from transformers import AutoModelForCausalLM

model = AutoModelForCausalLM.from_pretrained("distilgpt2")
model.generation_config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCausalLM.from_pretrained(<span class="hljs-string">&quot;distilgpt2&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model.generation_config
GenerationConfig {
    <span class="hljs-string">&quot;_from_model_config&quot;</span>: true,
    <span class="hljs-string">&quot;bos_token_id&quot;</span>: <span class="hljs-number">50256</span>,
    <span class="hljs-string">&quot;eos_token_id&quot;</span>: <span class="hljs-number">50256</span>,
    <span class="hljs-string">&quot;transformers_version&quot;</span>: <span class="hljs-string">&quot;4.26.0.dev0&quot;</span>
}`}}),Ae=new x({}),xe=new C({props:{code:"my_model.generate(**inputs, num_beams=4, do_sample=True)",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>my_model.generate(**inputs, num_beams=<span class="hljs-number">4</span>, do_sample=<span class="hljs-literal">True</span>)'}}),qe=new x({}),ze=new C({props:{code:`from transformers import AutoModelForCausalLM, GenerationConfig

model = AutoModelForCausalLM.from_pretrained("my_account/my_model")
generation_config = GenerationConfig(
    max_new_tokens=50, do_sample=True, top_k=50, eos_token_id=model.config.eos_token_id
)
generation_config.save_pretrained("my_account/my_model", push_to_hub=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForCausalLM, GenerationConfig

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCausalLM.from_pretrained(<span class="hljs-string">&quot;my_account/my_model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>generation_config = GenerationConfig(
<span class="hljs-meta">... </span>    max_new_tokens=<span class="hljs-number">50</span>, do_sample=<span class="hljs-literal">True</span>, top_k=<span class="hljs-number">50</span>, eos_token_id=model.config.eos_token_id
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>generation_config.save_pretrained(<span class="hljs-string">&quot;my_account/my_model&quot;</span>, push_to_hub=<span class="hljs-literal">True</span>)`}}),Me=new C({props:{code:`from transformers import AutoModelForSeq2SeqLM, AutoTokenizer, GenerationConfig

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = AutoModelForSeq2SeqLM.from_pretrained("t5-small")

translation_generation_config = GenerationConfig(
    num_beams=4,
    early_stopping=True,
    decoder_start_token_id=0,
    eos_token_id=model.config.eos_token_id,
    pad_token=model.config.pad_token_id,
)

translation_generation_config.save_pretrained("t5-small", "translation_generation_config.json", push_to_hub=True)

# You could then use the named generation config file to parameterize generation
generation_config = GenerationConfig.from_pretrained("t5-small", "translation_generation_config.json")
inputs = tokenizer("translate English to French: Configuration files are easy to use!", return_tensors="pt")
outputs = model.generate(**inputs, generation_config=generation_config)
print(tokenizer.batch_decode(outputs, skip_special_tokens=True))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForSeq2SeqLM, AutoTokenizer, GenerationConfig

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForSeq2SeqLM.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>translation_generation_config = GenerationConfig(
<span class="hljs-meta">... </span>    num_beams=<span class="hljs-number">4</span>,
<span class="hljs-meta">... </span>    early_stopping=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    decoder_start_token_id=<span class="hljs-number">0</span>,
<span class="hljs-meta">... </span>    eos_token_id=model.config.eos_token_id,
<span class="hljs-meta">... </span>    pad_token=model.config.pad_token_id,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>translation_generation_config.save_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>, <span class="hljs-string">&quot;translation_generation_config.json&quot;</span>, push_to_hub=<span class="hljs-literal">True</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># You could then use the named generation config file to parameterize generation</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generation_config = GenerationConfig.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>, <span class="hljs-string">&quot;translation_generation_config.json&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;translate English to French: Configuration files are easy to use!&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.generate(**inputs, generation_config=generation_config)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(tokenizer.batch_decode(outputs, skip_special_tokens=<span class="hljs-literal">True</span>))
[<span class="hljs-string">&#x27;Les fichiers de configuration sont faciles \xE0 utiliser !&#x27;</span>]`}}),Se=new x({}),Pe=new C({props:{code:`from transformers import AutoModelForCausalLM, AutoTokenizer, TextStreamer

tok = AutoTokenizer.from_pretrained("gpt2")
model = AutoModelForCausalLM.from_pretrained("gpt2")
inputs = tok(["An increasing sequence: one,"], return_tensors="pt")
streamer = TextStreamer(tok)

# Despite returning the usual output, the streamer will also print the generated text to stdout.
_ = model.generate(**inputs, streamer=streamer, max_new_tokens=20)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForCausalLM, AutoTokenizer, TextStreamer

<span class="hljs-meta">&gt;&gt;&gt; </span>tok = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;gpt2&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCausalLM.from_pretrained(<span class="hljs-string">&quot;gpt2&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tok([<span class="hljs-string">&quot;An increasing sequence: one,&quot;</span>], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>streamer = TextStreamer(tok)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Despite returning the usual output, the streamer will also print the generated text to stdout.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>_ = model.generate(**inputs, streamer=streamer, max_new_tokens=<span class="hljs-number">20</span>)
An increasing sequence: one, two, three, four, five, six, seven, eight, nine, ten, eleven,`}}),Le=new x({}),Fe=new x({}),Ie=new C({props:{code:`from transformers import AutoModelForCausalLM, AutoTokenizer

prompt = "I look forward to"
checkpoint = "distilgpt2"

tokenizer = AutoTokenizer.from_pretrained(checkpoint)
inputs = tokenizer(prompt, return_tensors="pt")

model = AutoModelForCausalLM.from_pretrained(checkpoint)
outputs = model.generate(**inputs)
tokenizer.batch_decode(outputs, skip_special_tokens=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForCausalLM, AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;I look forward to&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>checkpoint = <span class="hljs-string">&quot;distilgpt2&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(checkpoint)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCausalLM.from_pretrained(checkpoint)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.generate(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.batch_decode(outputs, skip_special_tokens=<span class="hljs-literal">True</span>)
[<span class="hljs-string">&#x27;I look forward to seeing you all again!\\n\\n\\n\\n\\n\\n\\n\\n\\n\\n\\n&#x27;</span>]`}}),Ge=new x({}),He=new C({props:{code:`from transformers import AutoTokenizer, AutoModelForCausalLM

checkpoint = "gpt2-large"
tokenizer = AutoTokenizer.from_pretrained(checkpoint)
model = AutoModelForCausalLM.from_pretrained(checkpoint)

prompt = "Hugging Face Company is"
inputs = tokenizer(prompt, return_tensors="pt")

outputs = model.generate(**inputs, penalty_alpha=0.6, top_k=4, max_new_tokens=100)
tokenizer.batch_decode(outputs, skip_special_tokens=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, AutoModelForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>checkpoint = <span class="hljs-string">&quot;gpt2-large&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(checkpoint)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCausalLM.from_pretrained(checkpoint)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;Hugging Face Company is&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.generate(**inputs, penalty_alpha=<span class="hljs-number">0.6</span>, top_k=<span class="hljs-number">4</span>, max_new_tokens=<span class="hljs-number">100</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.batch_decode(outputs, skip_special_tokens=<span class="hljs-literal">True</span>)
[<span class="hljs-string">&#x27;Hugging Face Company is a family owned and operated business. \\
We pride ourselves on being the best in the business and our customer service is second to none.\\
\\n\\nIf you have any questions about our products or services, feel free to contact us at any time.\\
 We look forward to hearing from you!&#x27;</span>]`}}),Ye=new x({}),We=new C({props:{code:`from transformers import AutoTokenizer, AutoModelForCausalLM

checkpoint = "gpt2-large"
tokenizer = AutoTokenizer.from_pretrained(checkpoint)
model = AutoModelForCausalLM.from_pretrained(checkpoint)

prompt = "Today was an amazing day because"
inputs = tokenizer(prompt, return_tensors="pt")

outputs = model.generate(**inputs, do_sample=True, max_new_tokens=100)
tokenizer.batch_decode(outputs, skip_special_tokens=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, AutoModelForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>checkpoint = <span class="hljs-string">&quot;gpt2-large&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(checkpoint)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCausalLM.from_pretrained(checkpoint)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;Today was an amazing day because&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.generate(**inputs, do_sample=<span class="hljs-literal">True</span>, max_new_tokens=<span class="hljs-number">100</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.batch_decode(outputs, skip_special_tokens=<span class="hljs-literal">True</span>)
[<span class="hljs-string">&#x27;Today was an amazing day because we are now in the final stages of our trip to New York City which was very tough. \\
It is a difficult schedule and a challenging part of the year but still worth it. I have been taking things easier and \\
I feel stronger and more motivated to be out there on their tour. Hopefully, that experience is going to help them with \\
their upcoming events which are currently scheduled in Australia.\\n\\nWe love that they are here. They want to make a \\
name for themselves and become famous for what they&#x27;</span>]`}}),Be=new x({}),Ue=new C({props:{code:`from transformers import AutoModelForCausalLM, AutoTokenizer

prompt = "It is astonishing how one can"
checkpoint = "gpt2-medium"

tokenizer = AutoTokenizer.from_pretrained(checkpoint)
inputs = tokenizer(prompt, return_tensors="pt")

model = AutoModelForCausalLM.from_pretrained(checkpoint)

outputs = model.generate(**inputs, num_beams=5, max_new_tokens=50)
tokenizer.batch_decode(outputs, skip_special_tokens=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForCausalLM, AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;It is astonishing how one can&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>checkpoint = <span class="hljs-string">&quot;gpt2-medium&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(checkpoint)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCausalLM.from_pretrained(checkpoint)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.generate(**inputs, num_beams=<span class="hljs-number">5</span>, max_new_tokens=<span class="hljs-number">50</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.batch_decode(outputs, skip_special_tokens=<span class="hljs-literal">True</span>)
[<span class="hljs-string">&#x27;It is astonishing how one can have such a profound impact on the lives of so many people in such a short period of \\
time.&quot;\\n\\nHe added: &quot;I am very proud of the work I have been able to do in the last few years.\\n\\n&quot;I have&#x27;</span>]`}}),Xe=new x({}),Re=new C({props:{code:`from transformers import AutoTokenizer, AutoModelForSeq2SeqLM

prompt = "translate English to German: The house is wonderful."
checkpoint = "t5-small"

tokenizer = AutoTokenizer.from_pretrained(checkpoint)
inputs = tokenizer(prompt, return_tensors="pt")

model = AutoModelForSeq2SeqLM.from_pretrained(checkpoint)

outputs = model.generate(**inputs, num_beams=5, do_sample=True)
tokenizer.decode(outputs[0], skip_special_tokens=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, AutoModelForSeq2SeqLM

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;translate English to German: The house is wonderful.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>checkpoint = <span class="hljs-string">&quot;t5-small&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(checkpoint)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForSeq2SeqLM.from_pretrained(checkpoint)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.generate(**inputs, num_beams=<span class="hljs-number">5</span>, do_sample=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.decode(outputs[<span class="hljs-number">0</span>], skip_special_tokens=<span class="hljs-literal">True</span>)
<span class="hljs-string">&#x27;Das Haus ist wunderbar.&#x27;</span>`}}),Ke=new x({}),Qe=new C({props:{code:`from transformers import AutoTokenizer, AutoModelForSeq2SeqLM

checkpoint = "google/pegasus-xsum"
prompt = "The Permaculture Design Principles are a set of universal design principles \\
that can be applied to any location, climate and culture, and they allow us to design \\
the most efficient and sustainable human habitation and food production systems. \\
Permaculture is a design system that encompasses a wide variety of disciplines, such \\
as ecology, landscape design, environmental science and energy conservation, and the \\
Permaculture design principles are drawn from these various disciplines. Each individual \\
design principle itself embodies a complete conceptual framework based on sound \\
scientific principles. When we bring all these separate  principles together, we can \\
create a design system that both looks at whole systems, the parts that these systems \\
consist of, and how those parts interact with each other to create a complex, dynamic, \\
living system. Each design principle serves as a tool that allows us to integrate all \\
the separate parts of a design, referred to as elements, into a functional, synergistic, \\
whole system, where the elements harmoniously interact and work together in the most \\
efficient way possible."

tokenizer = AutoTokenizer.from_pretrained(checkpoint)
inputs = tokenizer(prompt, return_tensors="pt")

model = AutoModelForSeq2SeqLM.from_pretrained(checkpoint)

outputs = model.generate(**inputs, num_beams=5, num_beam_groups=5, max_new_tokens=30)
tokenizer.decode(outputs[0], skip_special_tokens=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, AutoModelForSeq2SeqLM

<span class="hljs-meta">&gt;&gt;&gt; </span>checkpoint = <span class="hljs-string">&quot;google/pegasus-xsum&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;The Permaculture Design Principles are a set of universal design principles \\
&gt;&gt;&gt; that can be applied to any location, climate and culture, and they allow us to design \\
&gt;&gt;&gt; the most efficient and sustainable human habitation and food production systems. \\
&gt;&gt;&gt; Permaculture is a design system that encompasses a wide variety of disciplines, such \\
&gt;&gt;&gt; as ecology, landscape design, environmental science and energy conservation, and the \\
&gt;&gt;&gt; Permaculture design principles are drawn from these various disciplines. Each individual \\
&gt;&gt;&gt; design principle itself embodies a complete conceptual framework based on sound \\
&gt;&gt;&gt; scientific principles. When we bring all these separate  principles together, we can \\
&gt;&gt;&gt; create a design system that both looks at whole systems, the parts that these systems \\
&gt;&gt;&gt; consist of, and how those parts interact with each other to create a complex, dynamic, \\
&gt;&gt;&gt; living system. Each design principle serves as a tool that allows us to integrate all \\
&gt;&gt;&gt; the separate parts of a design, referred to as elements, into a functional, synergistic, \\
&gt;&gt;&gt; whole system, where the elements harmoniously interact and work together in the most \\
&gt;&gt;&gt; efficient way possible.&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(checkpoint)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForSeq2SeqLM.from_pretrained(checkpoint)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.generate(**inputs, num_beams=<span class="hljs-number">5</span>, num_beam_groups=<span class="hljs-number">5</span>, max_new_tokens=<span class="hljs-number">30</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.decode(outputs[<span class="hljs-number">0</span>], skip_special_tokens=<span class="hljs-literal">True</span>)
<span class="hljs-string">&#x27;The Design Principles are a set of universal design principles that can be applied to any location, climate and culture, and they allow us to design the most efficient and sustainable human habitation and food production systems.&#x27;</span>`}}),{c(){I=n("meta"),Ua=h(),G=n("h1"),Z=n("a"),Ct=n("span"),m(je.$$.fragment),co=h(),zt=n("span"),uo=s("Text generation strategies"),Xa=h(),Ze=n("p"),mo=s(`Text generation is essential to many NLP tasks, such as open-ended text generation, summarization, translation, and
more. It also plays a role in a variety of mixed-modality applications that have text as an output like speech-to-text
and vision-to-text. Some of the models that can generate text include
GPT2, XLNet, OpenAI GPT, CTRL, TransformerXL, XLM, Bart, T5, GIT, Whisper.`),Ra=h(),ee=n("p"),go=s("Check out a few examples that use "),et=n("a"),fo=s("generate()"),_o=s(` method to produce
text outputs for different tasks:`),Ka=h(),z=n("ul"),Mt=n("li"),tt=n("a"),vo=s("Text summarization"),yo=h(),St=n("li"),at=n("a"),ko=s("Image captioning"),wo=h(),Pt=n("li"),st=n("a"),bo=s("Audio transcription"),Ja=h(),ot=n("p"),Eo=s(`Note that the inputs to the generate method depend on the model\u2019s modality. They are returned by the model\u2019s preprocessor
class, such as AutoTokenizer or AutoProcessor. If a model\u2019s preprocessor creates more than one kind of input, pass all
the inputs to generate(). You can learn more about the individual model\u2019s preprocessor in the corresponding model\u2019s documentation.`),Qa=h(),te=n("p"),jo=s(`The process of selecting output tokens to generate text is known as decoding, and you can customize the decoding strategy
that the `),Lt=n("code"),$o=s("generate()"),To=s(` method will use. Modifying a decoding strategy does not change the values of any trainable parameters.
However, it can have a noticeable impact on the quality of the generated output. It can help reduce repetition in the text
and make it more coherent.`),Va=h(),nt=n("p"),Ao=s("This guide describes:"),Za=h(),M=n("ul"),Dt=n("li"),xo=s("default generation configuration"),qo=h(),Ft=n("li"),Co=s("common decoding strategies and their main parameters"),zo=h(),It=n("li"),Mo=s("saving and sharing custom generation configurations with your fine-tuned model on \u{1F917} Hub"),es=h(),O=n("h2"),ae=n("a"),Gt=n("span"),m($e.$$.fragment),So=h(),Ot=n("span"),Po=s("Default text generation configuration"),ts=h(),S=n("p"),Lo=s(`A decoding strategy for a model is defined in its generation configuration. When using pre-trained models for inference
within a `),rt=n("a"),Do=s("pipeline()"),Fo=s(", the models call the "),Nt=n("code"),Io=s("PreTrainedModel.generate()"),Go=s(` method that applies a default generation
configuration under the hood. The default configuration is also used when no custom configuration has been saved with
the model.`),as=h(),se=n("p"),Oo=s(`When you load a model explicitly, you can inspect the generation configuration that comes with it through
`),Ht=n("code"),No=s("model.generation_config"),Ho=s(":"),ss=h(),m(Te.$$.fragment),os=h(),oe=n("p"),Yo=s("Printing out the "),Yt=n("code"),Wo=s("model.generation_config"),Bo=s(` reveals only the values that are different from the default generation
configuration, and does not list any of the default values.`),ns=h(),it=n("p"),Uo=s(`The default generation configuration limits the size of the output combined with the input prompt to a maximum of 20
tokens to avoid running into resource limitations. The default decoding strategy is greedy search, which is the simplest decoding strategy that picks a token with the highest probability as the next token. For many tasks
and small output sizes this works well. However, when used to generate longer outputs, greedy search can start
producing highly repetitive results.`),rs=h(),N=n("h2"),ne=n("a"),Wt=n("span"),m(Ae.$$.fragment),Xo=h(),Bt=n("span"),Ro=s("Customize text generation"),is=h(),P=n("p"),Ko=s("You can override any "),Ut=n("code"),Jo=s("generation_config"),Qo=s(" by passing the parameters and their values directly to the "),Xt=n("code"),Vo=s("generate"),Zo=s(" method:"),ls=h(),m(xe.$$.fragment),ps=h(),lt=n("p"),en=s(`Even if the default decoding strategy mostly works for your task, you can still tweak a few things. Some of the
commonly adjusted parameters include:`),hs=h(),b=n("ul"),pt=n("li"),Rt=n("code"),tn=s("max_new_tokens"),an=s(`: the maximum number of tokens to generate. In other words, the size of the output sequence, not
including the tokens in the prompt.`),sn=h(),ht=n("li"),Kt=n("code"),on=s("num_beams"),nn=s(`: by specifying a number of beams higher than 1, you are effectively switching from greedy search to
beam search. This strategy evaluates several hypotheses at each time step and eventually chooses the hypothesis that
has the overall highest probability for the entire sequence. This has the advantage of identifying high-probability
sequences that start with a lower probability initial tokens and would\u2019ve been ignored by the greedy search.`),rn=h(),re=n("li"),Jt=n("code"),ln=s("do_sample"),pn=s(": if set to "),Qt=n("code"),hn=s("True"),cn=s(`, this parameter enables decoding strategies such as multinomial sampling, beam-search
multinomial sampling, Top-K sampling and Top-p sampling. All these strategies select the next token from the probability
distribution over the entire vocabulary with various strategy-specific adjustments.`),un=h(),ct=n("li"),Vt=n("code"),mn=s("num_return_sequences"),dn=s(`: the number of sequence candidates to return for each input. This options is only available for
the decoding strategies that support multiple sequence candidates, e.g. variations of beam search and sampling. Decoding
strategies like greedy search and contrastive search return a single output sequence.`),cs=h(),H=n("h2"),ie=n("a"),Zt=n("span"),m(qe.$$.fragment),gn=h(),ea=n("span"),fn=s("Save a custom decoding strategy with your model"),us=h(),ut=n("p"),_n=s("If you would like to share your fine-tuned model with a specific generation configuration, you can:"),ms=h(),E=n("ul"),Ce=n("li"),vn=s("Create a "),mt=n("a"),yn=s("GenerationConfig"),kn=s(" class instance"),wn=h(),ta=n("li"),bn=s("Specify the decoding strategy parameters"),En=h(),Y=n("li"),jn=s("Save your generation configuration with "),dt=n("a"),$n=s("GenerationConfig.save_pretrained()"),Tn=s(", making sure to leave its "),aa=n("code"),An=s("config_file_name"),xn=s(" argument empty"),qn=h(),W=n("li"),Cn=s("Set "),sa=n("code"),zn=s("push_to_hub"),Mn=s(" to "),oa=n("code"),Sn=s("True"),Pn=s(" to upload your config to the model\u2019s repo"),ds=h(),m(ze.$$.fragment),gs=h(),j=n("p"),Ln=s("You can also store several generation configurations in a single directory, making use of the "),na=n("code"),Dn=s("config_file_name"),Fn=s(`
argument in `),gt=n("a"),In=s("GenerationConfig.save_pretrained()"),Gn=s(". You can later instantiate them with "),ft=n("a"),On=s("GenerationConfig.from_pretrained()"),Nn=s(`. This is useful if you want to
store several generation configurations for a single model (e.g. one for creative text generation with sampling, and
one for summarization with beam search). You must have the right Hub permissions to add configuration files to a model.`),fs=h(),m(Me.$$.fragment),_s=h(),B=n("h2"),le=n("a"),ra=n("span"),m(Se.$$.fragment),Hn=h(),ia=n("span"),Yn=s("Streaming"),vs=h(),y=n("p"),Wn=s("The "),la=n("code"),Bn=s("generate()"),Un=s(" supports streaming, through its "),pa=n("code"),Xn=s("streamer"),Rn=s(" input. The "),ha=n("code"),Kn=s("streamer"),Jn=s(` input is compatible any instance
from a class that has the following methods: `),ca=n("code"),Qn=s("put()"),Vn=s(" and "),ua=n("code"),Zn=s("end()"),er=s(". Internally, "),ma=n("code"),tr=s("put()"),ar=s(` is used to push new tokens and
`),da=n("code"),sr=s("end()"),or=s(" is used to flag the end of text generation."),ys=h(),L=n("p"),nr=s(`In practice, you can craft your own streaming class for all sorts of purposes! We also have basic streaming classes
ready for you to use. For example, you can use the `),_t=n("a"),rr=s("TextStreamer"),ir=s(" class to stream the output of "),ga=n("code"),lr=s("generate()"),pr=s(` into
your screen, one word at a time:`),ks=h(),m(Pe.$$.fragment),ws=h(),U=n("h2"),pe=n("a"),fa=n("span"),m(Le.$$.fragment),hr=h(),_a=n("span"),cr=s("Decoding strategies"),bs=h(),$=n("p"),ur=s("Certain combinations of the "),va=n("code"),mr=s("generate()"),dr=s(" parameters, and ultimately "),ya=n("code"),gr=s("generation_config"),fr=s(`, can be used to enable specific
decoding strategies. If you are new to this concept, we recommend reading `),De=n("a"),_r=s("this blog post that illustrates how common decoding strategies work"),vr=s("."),Es=h(),vt=n("p"),yr=s("Here, we\u2019ll show some of the parameters that control the decoding strategies and illustrate how you can use them."),js=h(),X=n("h3"),he=n("a"),ka=n("span"),m(Fe.$$.fragment),kr=h(),wa=n("span"),wr=s("Greedy Search"),$s=h(),q=n("p"),ba=n("code"),br=s("generate"),Er=s(" uses greedy search decoding by default so you don\u2019t have to pass any parameters to enable it. This means the parameters "),Ea=n("code"),jr=s("num_beams"),$r=s(" is set to 1 and "),ja=n("code"),Tr=s("do_sample=False"),Ar=s("."),Ts=h(),m(Ie.$$.fragment),As=h(),R=n("h3"),ce=n("a"),$a=n("span"),m(Ge.$$.fragment),xr=h(),Ta=n("span"),qr=s("Contrastive search"),xs=h(),w=n("p"),Cr=s("The contrastive search decoding strategy was proposed in the 2022 paper "),Oe=n("a"),zr=s("A Contrastive Framework for Neural Text Generation"),Mr=s(`.
It demonstrates superior results for generating non-repetitive yet coherent long outputs. To learn how contrastive search
works, check out `),Ne=n("a"),Sr=s("this blog post"),Pr=s(`.
The two main parameters that enable and control the behavior of contrastive search are `),Aa=n("code"),Lr=s("penalty_alpha"),Dr=s(" and "),xa=n("code"),Fr=s("top_k"),Ir=s(":"),qs=h(),m(He.$$.fragment),Cs=h(),K=n("h3"),ue=n("a"),qa=n("span"),m(Ye.$$.fragment),Gr=h(),Ca=n("span"),Or=s("Multinomial sampling"),zs=h(),yt=n("p"),Nr=s(`As opposed to greedy search that always chooses a token with the highest probability as the
next token, multinomial sampling randomly selects the next token based on the probability distribution over the entire
vocabulary given by the model. Every token with a non-zero probability has a chance of being selected, thus reducing the
risk of repetition.`),Ms=h(),me=n("p"),Hr=s("To enable multinomial sampling set "),za=n("code"),Yr=s("do_sample=True"),Wr=s("."),Ss=h(),m(We.$$.fragment),Ps=h(),J=n("h3"),de=n("a"),Ma=n("span"),m(Be.$$.fragment),Br=h(),Sa=n("span"),Ur=s("Beam-search decoding"),Ls=h(),kt=n("p"),Xr=s(`Unlike greedy search, beam-search decoding keeps several hypotheses at each time step and eventually chooses
the hypothesis that has the overall highest probability for the entire sequence. This has the advantage of identifying high-probability
sequences that start with lower probability initial tokens and would\u2019ve been ignored by the greedy search.`),Ds=h(),ge=n("p"),Rr=s("To enable this decoding strategy, specify the "),Pa=n("code"),Kr=s("num_beams"),Jr=s(" (aka number of hypotheses to keep track of) that is greater than 1."),Fs=h(),m(Ue.$$.fragment),Is=h(),Q=n("h3"),fe=n("a"),La=n("span"),m(Xe.$$.fragment),Qr=h(),Da=n("span"),Vr=s("Beam-search multinomial sampling"),Gs=h(),D=n("p"),Zr=s(`As the name implies, this decoding strategy combines beam search with multinomial sampling. You need to specify
the `),Fa=n("code"),ei=s("num_beams"),ti=s(" greater than 1, and set "),Ia=n("code"),ai=s("do_sample=True"),si=s(" to use this decoding strategy."),Os=h(),m(Re.$$.fragment),Ns=h(),V=n("h3"),_e=n("a"),Ga=n("span"),m(Ke.$$.fragment),oi=h(),Oa=n("span"),ni=s("Diverse beam search decoding"),Hs=h(),T=n("p"),ri=s(`The diverse beam search decoding strategy is an extension of the beam search strategy that allows for generating a more diverse
set of beam sequences to choose from. To learn how it works, refer to `),Je=n("a"),ii=s("Diverse Beam Search: Decoding Diverse Solutions from Neural Sequence Models"),li=s(`.
This approach has two main parameters: `),Na=n("code"),pi=s("num_beams"),hi=s(" and "),Ha=n("code"),ci=s("num_beam_groups"),ui=s(`.
The groups are selected to ensure they are distinct enough compared to the others, and regular beam search is used within each group.`),Ys=h(),m(Qe.$$.fragment),Ws=h(),A=n("p"),mi=s(`This guide illustrates the main parameters that enable various decoding strategies. More advanced parameters exist for the
`),Ya=n("code"),di=s("generate"),gi=s(" method, which gives you even further control over the "),Wa=n("code"),fi=s("generate"),_i=s(` method\u2019s behavior.
For the complete list of the available parameters, refer to the `),wt=n("a"),vi=s("API documentation"),yi=s("."),this.h()},l(e){const l=jp('[data-svelte="svelte-1phssyn"]',document.head);I=r(l,"META",{name:!0,content:!0}),l.forEach(a),Ua=c(e),G=r(e,"H1",{class:!0});var Us=i(G);Z=r(Us,"A",{id:!0,class:!0,href:!0});var ji=i(Z);Ct=r(ji,"SPAN",{});var $i=i(Ct);d(je.$$.fragment,$i),$i.forEach(a),ji.forEach(a),co=c(Us),zt=r(Us,"SPAN",{});var Ti=i(zt);uo=o(Ti,"Text generation strategies"),Ti.forEach(a),Us.forEach(a),Xa=c(e),Ze=r(e,"P",{});var Ai=i(Ze);mo=o(Ai,`Text generation is essential to many NLP tasks, such as open-ended text generation, summarization, translation, and
more. It also plays a role in a variety of mixed-modality applications that have text as an output like speech-to-text
and vision-to-text. Some of the models that can generate text include
GPT2, XLNet, OpenAI GPT, CTRL, TransformerXL, XLM, Bart, T5, GIT, Whisper.`),Ai.forEach(a),Ra=c(e),ee=r(e,"P",{});var Xs=i(ee);go=o(Xs,"Check out a few examples that use "),et=r(Xs,"A",{href:!0});var xi=i(et);fo=o(xi,"generate()"),xi.forEach(a),_o=o(Xs,` method to produce
text outputs for different tasks:`),Xs.forEach(a),Ka=c(e),z=r(e,"UL",{});var bt=i(z);Mt=r(bt,"LI",{});var qi=i(Mt);tt=r(qi,"A",{href:!0});var Ci=i(tt);vo=o(Ci,"Text summarization"),Ci.forEach(a),qi.forEach(a),yo=c(bt),St=r(bt,"LI",{});var zi=i(St);at=r(zi,"A",{href:!0});var Mi=i(at);ko=o(Mi,"Image captioning"),Mi.forEach(a),zi.forEach(a),wo=c(bt),Pt=r(bt,"LI",{});var Si=i(Pt);st=r(Si,"A",{href:!0});var Pi=i(st);bo=o(Pi,"Audio transcription"),Pi.forEach(a),Si.forEach(a),bt.forEach(a),Ja=c(e),ot=r(e,"P",{});var Li=i(ot);Eo=o(Li,`Note that the inputs to the generate method depend on the model\u2019s modality. They are returned by the model\u2019s preprocessor
class, such as AutoTokenizer or AutoProcessor. If a model\u2019s preprocessor creates more than one kind of input, pass all
the inputs to generate(). You can learn more about the individual model\u2019s preprocessor in the corresponding model\u2019s documentation.`),Li.forEach(a),Qa=c(e),te=r(e,"P",{});var Rs=i(te);jo=o(Rs,`The process of selecting output tokens to generate text is known as decoding, and you can customize the decoding strategy
that the `),Lt=r(Rs,"CODE",{});var Di=i(Lt);$o=o(Di,"generate()"),Di.forEach(a),To=o(Rs,` method will use. Modifying a decoding strategy does not change the values of any trainable parameters.
However, it can have a noticeable impact on the quality of the generated output. It can help reduce repetition in the text
and make it more coherent.`),Rs.forEach(a),Va=c(e),nt=r(e,"P",{});var Fi=i(nt);Ao=o(Fi,"This guide describes:"),Fi.forEach(a),Za=c(e),M=r(e,"UL",{});var Et=i(M);Dt=r(Et,"LI",{});var Ii=i(Dt);xo=o(Ii,"default generation configuration"),Ii.forEach(a),qo=c(Et),Ft=r(Et,"LI",{});var Gi=i(Ft);Co=o(Gi,"common decoding strategies and their main parameters"),Gi.forEach(a),zo=c(Et),It=r(Et,"LI",{});var Oi=i(It);Mo=o(Oi,"saving and sharing custom generation configurations with your fine-tuned model on \u{1F917} Hub"),Oi.forEach(a),Et.forEach(a),es=c(e),O=r(e,"H2",{class:!0});var Ks=i(O);ae=r(Ks,"A",{id:!0,class:!0,href:!0});var Ni=i(ae);Gt=r(Ni,"SPAN",{});var Hi=i(Gt);d($e.$$.fragment,Hi),Hi.forEach(a),Ni.forEach(a),So=c(Ks),Ot=r(Ks,"SPAN",{});var Yi=i(Ot);Po=o(Yi,"Default text generation configuration"),Yi.forEach(a),Ks.forEach(a),ts=c(e),S=r(e,"P",{});var jt=i(S);Lo=o(jt,`A decoding strategy for a model is defined in its generation configuration. When using pre-trained models for inference
within a `),rt=r(jt,"A",{href:!0});var Wi=i(rt);Do=o(Wi,"pipeline()"),Wi.forEach(a),Fo=o(jt,", the models call the "),Nt=r(jt,"CODE",{});var Bi=i(Nt);Io=o(Bi,"PreTrainedModel.generate()"),Bi.forEach(a),Go=o(jt,` method that applies a default generation
configuration under the hood. The default configuration is also used when no custom configuration has been saved with
the model.`),jt.forEach(a),as=c(e),se=r(e,"P",{});var Js=i(se);Oo=o(Js,`When you load a model explicitly, you can inspect the generation configuration that comes with it through
`),Ht=r(Js,"CODE",{});var Ui=i(Ht);No=o(Ui,"model.generation_config"),Ui.forEach(a),Ho=o(Js,":"),Js.forEach(a),ss=c(e),d(Te.$$.fragment,e),os=c(e),oe=r(e,"P",{});var Qs=i(oe);Yo=o(Qs,"Printing out the "),Yt=r(Qs,"CODE",{});var Xi=i(Yt);Wo=o(Xi,"model.generation_config"),Xi.forEach(a),Bo=o(Qs,` reveals only the values that are different from the default generation
configuration, and does not list any of the default values.`),Qs.forEach(a),ns=c(e),it=r(e,"P",{});var Ri=i(it);Uo=o(Ri,`The default generation configuration limits the size of the output combined with the input prompt to a maximum of 20
tokens to avoid running into resource limitations. The default decoding strategy is greedy search, which is the simplest decoding strategy that picks a token with the highest probability as the next token. For many tasks
and small output sizes this works well. However, when used to generate longer outputs, greedy search can start
producing highly repetitive results.`),Ri.forEach(a),rs=c(e),N=r(e,"H2",{class:!0});var Vs=i(N);ne=r(Vs,"A",{id:!0,class:!0,href:!0});var Ki=i(ne);Wt=r(Ki,"SPAN",{});var Ji=i(Wt);d(Ae.$$.fragment,Ji),Ji.forEach(a),Ki.forEach(a),Xo=c(Vs),Bt=r(Vs,"SPAN",{});var Qi=i(Bt);Ro=o(Qi,"Customize text generation"),Qi.forEach(a),Vs.forEach(a),is=c(e),P=r(e,"P",{});var $t=i(P);Ko=o($t,"You can override any "),Ut=r($t,"CODE",{});var Vi=i(Ut);Jo=o(Vi,"generation_config"),Vi.forEach(a),Qo=o($t," by passing the parameters and their values directly to the "),Xt=r($t,"CODE",{});var Zi=i(Xt);Vo=o(Zi,"generate"),Zi.forEach(a),Zo=o($t," method:"),$t.forEach(a),ls=c(e),d(xe.$$.fragment,e),ps=c(e),lt=r(e,"P",{});var el=i(lt);en=o(el,`Even if the default decoding strategy mostly works for your task, you can still tweak a few things. Some of the
commonly adjusted parameters include:`),el.forEach(a),hs=c(e),b=r(e,"UL",{});var ve=i(b);pt=r(ve,"LI",{});var ki=i(pt);Rt=r(ki,"CODE",{});var tl=i(Rt);tn=o(tl,"max_new_tokens"),tl.forEach(a),an=o(ki,`: the maximum number of tokens to generate. In other words, the size of the output sequence, not
including the tokens in the prompt.`),ki.forEach(a),sn=c(ve),ht=r(ve,"LI",{});var wi=i(ht);Kt=r(wi,"CODE",{});var al=i(Kt);on=o(al,"num_beams"),al.forEach(a),nn=o(wi,`: by specifying a number of beams higher than 1, you are effectively switching from greedy search to
beam search. This strategy evaluates several hypotheses at each time step and eventually chooses the hypothesis that
has the overall highest probability for the entire sequence. This has the advantage of identifying high-probability
sequences that start with a lower probability initial tokens and would\u2019ve been ignored by the greedy search.`),wi.forEach(a),rn=c(ve),re=r(ve,"LI",{});var Ba=i(re);Jt=r(Ba,"CODE",{});var sl=i(Jt);ln=o(sl,"do_sample"),sl.forEach(a),pn=o(Ba,": if set to "),Qt=r(Ba,"CODE",{});var ol=i(Qt);hn=o(ol,"True"),ol.forEach(a),cn=o(Ba,`, this parameter enables decoding strategies such as multinomial sampling, beam-search
multinomial sampling, Top-K sampling and Top-p sampling. All these strategies select the next token from the probability
distribution over the entire vocabulary with various strategy-specific adjustments.`),Ba.forEach(a),un=c(ve),ct=r(ve,"LI",{});var bi=i(ct);Vt=r(bi,"CODE",{});var nl=i(Vt);mn=o(nl,"num_return_sequences"),nl.forEach(a),dn=o(bi,`: the number of sequence candidates to return for each input. This options is only available for
the decoding strategies that support multiple sequence candidates, e.g. variations of beam search and sampling. Decoding
strategies like greedy search and contrastive search return a single output sequence.`),bi.forEach(a),ve.forEach(a),cs=c(e),H=r(e,"H2",{class:!0});var Zs=i(H);ie=r(Zs,"A",{id:!0,class:!0,href:!0});var rl=i(ie);Zt=r(rl,"SPAN",{});var il=i(Zt);d(qe.$$.fragment,il),il.forEach(a),rl.forEach(a),gn=c(Zs),ea=r(Zs,"SPAN",{});var ll=i(ea);fn=o(ll,"Save a custom decoding strategy with your model"),ll.forEach(a),Zs.forEach(a),us=c(e),ut=r(e,"P",{});var pl=i(ut);_n=o(pl,"If you would like to share your fine-tuned model with a specific generation configuration, you can:"),pl.forEach(a),ms=c(e),E=r(e,"UL",{});var ye=i(E);Ce=r(ye,"LI",{});var eo=i(Ce);vn=o(eo,"Create a "),mt=r(eo,"A",{href:!0});var hl=i(mt);yn=o(hl,"GenerationConfig"),hl.forEach(a),kn=o(eo," class instance"),eo.forEach(a),wn=c(ye),ta=r(ye,"LI",{});var cl=i(ta);bn=o(cl,"Specify the decoding strategy parameters"),cl.forEach(a),En=c(ye),Y=r(ye,"LI",{});var Tt=i(Y);jn=o(Tt,"Save your generation configuration with "),dt=r(Tt,"A",{href:!0});var ul=i(dt);$n=o(ul,"GenerationConfig.save_pretrained()"),ul.forEach(a),Tn=o(Tt,", making sure to leave its "),aa=r(Tt,"CODE",{});var ml=i(aa);An=o(ml,"config_file_name"),ml.forEach(a),xn=o(Tt," argument empty"),Tt.forEach(a),qn=c(ye),W=r(ye,"LI",{});var At=i(W);Cn=o(At,"Set "),sa=r(At,"CODE",{});var dl=i(sa);zn=o(dl,"push_to_hub"),dl.forEach(a),Mn=o(At," to "),oa=r(At,"CODE",{});var gl=i(oa);Sn=o(gl,"True"),gl.forEach(a),Pn=o(At," to upload your config to the model\u2019s repo"),At.forEach(a),ye.forEach(a),ds=c(e),d(ze.$$.fragment,e),gs=c(e),j=r(e,"P",{});var ke=i(j);Ln=o(ke,"You can also store several generation configurations in a single directory, making use of the "),na=r(ke,"CODE",{});var fl=i(na);Dn=o(fl,"config_file_name"),fl.forEach(a),Fn=o(ke,`
argument in `),gt=r(ke,"A",{href:!0});var _l=i(gt);In=o(_l,"GenerationConfig.save_pretrained()"),_l.forEach(a),Gn=o(ke,". You can later instantiate them with "),ft=r(ke,"A",{href:!0});var vl=i(ft);On=o(vl,"GenerationConfig.from_pretrained()"),vl.forEach(a),Nn=o(ke,`. This is useful if you want to
store several generation configurations for a single model (e.g. one for creative text generation with sampling, and
one for summarization with beam search). You must have the right Hub permissions to add configuration files to a model.`),ke.forEach(a),fs=c(e),d(Me.$$.fragment,e),_s=c(e),B=r(e,"H2",{class:!0});var to=i(B);le=r(to,"A",{id:!0,class:!0,href:!0});var yl=i(le);ra=r(yl,"SPAN",{});var kl=i(ra);d(Se.$$.fragment,kl),kl.forEach(a),yl.forEach(a),Hn=c(to),ia=r(to,"SPAN",{});var wl=i(ia);Yn=o(wl,"Streaming"),wl.forEach(a),to.forEach(a),vs=c(e),y=r(e,"P",{});var k=i(y);Wn=o(k,"The "),la=r(k,"CODE",{});var bl=i(la);Bn=o(bl,"generate()"),bl.forEach(a),Un=o(k," supports streaming, through its "),pa=r(k,"CODE",{});var El=i(pa);Xn=o(El,"streamer"),El.forEach(a),Rn=o(k," input. The "),ha=r(k,"CODE",{});var jl=i(ha);Kn=o(jl,"streamer"),jl.forEach(a),Jn=o(k,` input is compatible any instance
from a class that has the following methods: `),ca=r(k,"CODE",{});var $l=i(ca);Qn=o($l,"put()"),$l.forEach(a),Vn=o(k," and "),ua=r(k,"CODE",{});var Tl=i(ua);Zn=o(Tl,"end()"),Tl.forEach(a),er=o(k,". Internally, "),ma=r(k,"CODE",{});var Al=i(ma);tr=o(Al,"put()"),Al.forEach(a),ar=o(k,` is used to push new tokens and
`),da=r(k,"CODE",{});var xl=i(da);sr=o(xl,"end()"),xl.forEach(a),or=o(k," is used to flag the end of text generation."),k.forEach(a),ys=c(e),L=r(e,"P",{});var xt=i(L);nr=o(xt,`In practice, you can craft your own streaming class for all sorts of purposes! We also have basic streaming classes
ready for you to use. For example, you can use the `),_t=r(xt,"A",{href:!0});var ql=i(_t);rr=o(ql,"TextStreamer"),ql.forEach(a),ir=o(xt," class to stream the output of "),ga=r(xt,"CODE",{});var Cl=i(ga);lr=o(Cl,"generate()"),Cl.forEach(a),pr=o(xt,` into
your screen, one word at a time:`),xt.forEach(a),ks=c(e),d(Pe.$$.fragment,e),ws=c(e),U=r(e,"H2",{class:!0});var ao=i(U);pe=r(ao,"A",{id:!0,class:!0,href:!0});var zl=i(pe);fa=r(zl,"SPAN",{});var Ml=i(fa);d(Le.$$.fragment,Ml),Ml.forEach(a),zl.forEach(a),hr=c(ao),_a=r(ao,"SPAN",{});var Sl=i(_a);cr=o(Sl,"Decoding strategies"),Sl.forEach(a),ao.forEach(a),bs=c(e),$=r(e,"P",{});var we=i($);ur=o(we,"Certain combinations of the "),va=r(we,"CODE",{});var Pl=i(va);mr=o(Pl,"generate()"),Pl.forEach(a),dr=o(we," parameters, and ultimately "),ya=r(we,"CODE",{});var Ll=i(ya);gr=o(Ll,"generation_config"),Ll.forEach(a),fr=o(we,`, can be used to enable specific
decoding strategies. If you are new to this concept, we recommend reading `),De=r(we,"A",{href:!0,rel:!0});var Dl=i(De);_r=o(Dl,"this blog post that illustrates how common decoding strategies work"),Dl.forEach(a),vr=o(we,"."),we.forEach(a),Es=c(e),vt=r(e,"P",{});var Fl=i(vt);yr=o(Fl,"Here, we\u2019ll show some of the parameters that control the decoding strategies and illustrate how you can use them."),Fl.forEach(a),js=c(e),X=r(e,"H3",{class:!0});var so=i(X);he=r(so,"A",{id:!0,class:!0,href:!0});var Il=i(he);ka=r(Il,"SPAN",{});var Gl=i(ka);d(Fe.$$.fragment,Gl),Gl.forEach(a),Il.forEach(a),kr=c(so),wa=r(so,"SPAN",{});var Ol=i(wa);wr=o(Ol,"Greedy Search"),Ol.forEach(a),so.forEach(a),$s=c(e),q=r(e,"P",{});var Ve=i(q);ba=r(Ve,"CODE",{});var Nl=i(ba);br=o(Nl,"generate"),Nl.forEach(a),Er=o(Ve," uses greedy search decoding by default so you don\u2019t have to pass any parameters to enable it. This means the parameters "),Ea=r(Ve,"CODE",{});var Hl=i(Ea);jr=o(Hl,"num_beams"),Hl.forEach(a),$r=o(Ve," is set to 1 and "),ja=r(Ve,"CODE",{});var Yl=i(ja);Tr=o(Yl,"do_sample=False"),Yl.forEach(a),Ar=o(Ve,"."),Ve.forEach(a),Ts=c(e),d(Ie.$$.fragment,e),As=c(e),R=r(e,"H3",{class:!0});var oo=i(R);ce=r(oo,"A",{id:!0,class:!0,href:!0});var Wl=i(ce);$a=r(Wl,"SPAN",{});var Bl=i($a);d(Ge.$$.fragment,Bl),Bl.forEach(a),Wl.forEach(a),xr=c(oo),Ta=r(oo,"SPAN",{});var Ul=i(Ta);qr=o(Ul,"Contrastive search"),Ul.forEach(a),oo.forEach(a),xs=c(e),w=r(e,"P",{});var F=i(w);Cr=o(F,"The contrastive search decoding strategy was proposed in the 2022 paper "),Oe=r(F,"A",{href:!0,rel:!0});var Xl=i(Oe);zr=o(Xl,"A Contrastive Framework for Neural Text Generation"),Xl.forEach(a),Mr=o(F,`.
It demonstrates superior results for generating non-repetitive yet coherent long outputs. To learn how contrastive search
works, check out `),Ne=r(F,"A",{href:!0,rel:!0});var Rl=i(Ne);Sr=o(Rl,"this blog post"),Rl.forEach(a),Pr=o(F,`.
The two main parameters that enable and control the behavior of contrastive search are `),Aa=r(F,"CODE",{});var Kl=i(Aa);Lr=o(Kl,"penalty_alpha"),Kl.forEach(a),Dr=o(F," and "),xa=r(F,"CODE",{});var Jl=i(xa);Fr=o(Jl,"top_k"),Jl.forEach(a),Ir=o(F,":"),F.forEach(a),qs=c(e),d(He.$$.fragment,e),Cs=c(e),K=r(e,"H3",{class:!0});var no=i(K);ue=r(no,"A",{id:!0,class:!0,href:!0});var Ql=i(ue);qa=r(Ql,"SPAN",{});var Vl=i(qa);d(Ye.$$.fragment,Vl),Vl.forEach(a),Ql.forEach(a),Gr=c(no),Ca=r(no,"SPAN",{});var Zl=i(Ca);Or=o(Zl,"Multinomial sampling"),Zl.forEach(a),no.forEach(a),zs=c(e),yt=r(e,"P",{});var ep=i(yt);Nr=o(ep,`As opposed to greedy search that always chooses a token with the highest probability as the
next token, multinomial sampling randomly selects the next token based on the probability distribution over the entire
vocabulary given by the model. Every token with a non-zero probability has a chance of being selected, thus reducing the
risk of repetition.`),ep.forEach(a),Ms=c(e),me=r(e,"P",{});var ro=i(me);Hr=o(ro,"To enable multinomial sampling set "),za=r(ro,"CODE",{});var tp=i(za);Yr=o(tp,"do_sample=True"),tp.forEach(a),Wr=o(ro,"."),ro.forEach(a),Ss=c(e),d(We.$$.fragment,e),Ps=c(e),J=r(e,"H3",{class:!0});var io=i(J);de=r(io,"A",{id:!0,class:!0,href:!0});var ap=i(de);Ma=r(ap,"SPAN",{});var sp=i(Ma);d(Be.$$.fragment,sp),sp.forEach(a),ap.forEach(a),Br=c(io),Sa=r(io,"SPAN",{});var op=i(Sa);Ur=o(op,"Beam-search decoding"),op.forEach(a),io.forEach(a),Ls=c(e),kt=r(e,"P",{});var np=i(kt);Xr=o(np,`Unlike greedy search, beam-search decoding keeps several hypotheses at each time step and eventually chooses
the hypothesis that has the overall highest probability for the entire sequence. This has the advantage of identifying high-probability
sequences that start with lower probability initial tokens and would\u2019ve been ignored by the greedy search.`),np.forEach(a),Ds=c(e),ge=r(e,"P",{});var lo=i(ge);Rr=o(lo,"To enable this decoding strategy, specify the "),Pa=r(lo,"CODE",{});var rp=i(Pa);Kr=o(rp,"num_beams"),rp.forEach(a),Jr=o(lo," (aka number of hypotheses to keep track of) that is greater than 1."),lo.forEach(a),Fs=c(e),d(Ue.$$.fragment,e),Is=c(e),Q=r(e,"H3",{class:!0});var po=i(Q);fe=r(po,"A",{id:!0,class:!0,href:!0});var ip=i(fe);La=r(ip,"SPAN",{});var lp=i(La);d(Xe.$$.fragment,lp),lp.forEach(a),ip.forEach(a),Qr=c(po),Da=r(po,"SPAN",{});var pp=i(Da);Vr=o(pp,"Beam-search multinomial sampling"),pp.forEach(a),po.forEach(a),Gs=c(e),D=r(e,"P",{});var qt=i(D);Zr=o(qt,`As the name implies, this decoding strategy combines beam search with multinomial sampling. You need to specify
the `),Fa=r(qt,"CODE",{});var hp=i(Fa);ei=o(hp,"num_beams"),hp.forEach(a),ti=o(qt," greater than 1, and set "),Ia=r(qt,"CODE",{});var cp=i(Ia);ai=o(cp,"do_sample=True"),cp.forEach(a),si=o(qt," to use this decoding strategy."),qt.forEach(a),Os=c(e),d(Re.$$.fragment,e),Ns=c(e),V=r(e,"H3",{class:!0});var ho=i(V);_e=r(ho,"A",{id:!0,class:!0,href:!0});var up=i(_e);Ga=r(up,"SPAN",{});var mp=i(Ga);d(Ke.$$.fragment,mp),mp.forEach(a),up.forEach(a),oi=c(ho),Oa=r(ho,"SPAN",{});var dp=i(Oa);ni=o(dp,"Diverse beam search decoding"),dp.forEach(a),ho.forEach(a),Hs=c(e),T=r(e,"P",{});var be=i(T);ri=o(be,`The diverse beam search decoding strategy is an extension of the beam search strategy that allows for generating a more diverse
set of beam sequences to choose from. To learn how it works, refer to `),Je=r(be,"A",{href:!0,rel:!0});var gp=i(Je);ii=o(gp,"Diverse Beam Search: Decoding Diverse Solutions from Neural Sequence Models"),gp.forEach(a),li=o(be,`.
This approach has two main parameters: `),Na=r(be,"CODE",{});var fp=i(Na);pi=o(fp,"num_beams"),fp.forEach(a),hi=o(be," and "),Ha=r(be,"CODE",{});var _p=i(Ha);ci=o(_p,"num_beam_groups"),_p.forEach(a),ui=o(be,`.
The groups are selected to ensure they are distinct enough compared to the others, and regular beam search is used within each group.`),be.forEach(a),Ys=c(e),d(Qe.$$.fragment,e),Ws=c(e),A=r(e,"P",{});var Ee=i(A);mi=o(Ee,`This guide illustrates the main parameters that enable various decoding strategies. More advanced parameters exist for the
`),Ya=r(Ee,"CODE",{});var vp=i(Ya);di=o(vp,"generate"),vp.forEach(a),gi=o(Ee," method, which gives you even further control over the "),Wa=r(Ee,"CODE",{});var yp=i(Wa);fi=o(yp,"generate"),yp.forEach(a),_i=o(Ee,` method\u2019s behavior.
For the complete list of the available parameters, refer to the `),wt=r(Ee,"A",{href:!0});var kp=i(wt);vi=o(kp,"API documentation"),kp.forEach(a),yi=o(Ee,"."),Ee.forEach(a),this.h()},h(){u(I,"name","hf:doc:metadata"),u(I,"content",JSON.stringify(xp)),u(Z,"id","text-generation-strategies"),u(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Z,"href","#text-generation-strategies"),u(G,"class","relative group"),u(et,"href","/docs/transformers/main/en/main_classes/text_generation#transformers.GenerationMixin.generate"),u(tt,"href","./tasks/summarization#inference"),u(at,"href","./model_doc/git#transformers.GitForCausalLM.forward.example"),u(st,"href","./model_doc/whisper#transformers.WhisperForConditionalGeneration.forward.example"),u(ae,"id","default-text-generation-configuration"),u(ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(ae,"href","#default-text-generation-configuration"),u(O,"class","relative group"),u(rt,"href","/docs/transformers/main/en/main_classes/pipelines#transformers.pipeline"),u(ne,"id","customize-text-generation"),u(ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(ne,"href","#customize-text-generation"),u(N,"class","relative group"),u(ie,"id","save-a-custom-decoding-strategy-with-your-model"),u(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(ie,"href","#save-a-custom-decoding-strategy-with-your-model"),u(H,"class","relative group"),u(mt,"href","/docs/transformers/main/en/main_classes/text_generation#transformers.GenerationConfig"),u(dt,"href","/docs/transformers/main/en/main_classes/text_generation#transformers.GenerationConfig.save_pretrained"),u(gt,"href","/docs/transformers/main/en/main_classes/text_generation#transformers.GenerationConfig.save_pretrained"),u(ft,"href","/docs/transformers/main/en/main_classes/text_generation#transformers.GenerationConfig.from_pretrained"),u(le,"id","streaming"),u(le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(le,"href","#streaming"),u(B,"class","relative group"),u(_t,"href","/docs/transformers/main/en/internal/generation_utils#transformers.TextStreamer"),u(pe,"id","decoding-strategies"),u(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(pe,"href","#decoding-strategies"),u(U,"class","relative group"),u(De,"href","https://huggingface.co/blog/how-to-generate"),u(De,"rel","nofollow"),u(he,"id","greedy-search"),u(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(he,"href","#greedy-search"),u(X,"class","relative group"),u(ce,"id","contrastive-search"),u(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(ce,"href","#contrastive-search"),u(R,"class","relative group"),u(Oe,"href","https://arxiv.org/abs/2202.06417"),u(Oe,"rel","nofollow"),u(Ne,"href","https://huggingface.co/blog/introducing-csearch"),u(Ne,"rel","nofollow"),u(ue,"id","multinomial-sampling"),u(ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(ue,"href","#multinomial-sampling"),u(K,"class","relative group"),u(de,"id","beamsearch-decoding"),u(de,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(de,"href","#beamsearch-decoding"),u(J,"class","relative group"),u(fe,"id","beamsearch-multinomial-sampling"),u(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(fe,"href","#beamsearch-multinomial-sampling"),u(Q,"class","relative group"),u(_e,"id","diverse-beam-search-decoding"),u(_e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(_e,"href","#diverse-beam-search-decoding"),u(V,"class","relative group"),u(Je,"href","https://arxiv.org/pdf/1610.02424.pdf"),u(Je,"rel","nofollow"),u(wt,"href","./main_classes/text_generation.mdx")},m(e,l){t(document.head,I),p(e,Ua,l),p(e,G,l),t(G,Z),t(Z,Ct),g(je,Ct,null),t(G,co),t(G,zt),t(zt,uo),p(e,Xa,l),p(e,Ze,l),t(Ze,mo),p(e,Ra,l),p(e,ee,l),t(ee,go),t(ee,et),t(et,fo),t(ee,_o),p(e,Ka,l),p(e,z,l),t(z,Mt),t(Mt,tt),t(tt,vo),t(z,yo),t(z,St),t(St,at),t(at,ko),t(z,wo),t(z,Pt),t(Pt,st),t(st,bo),p(e,Ja,l),p(e,ot,l),t(ot,Eo),p(e,Qa,l),p(e,te,l),t(te,jo),t(te,Lt),t(Lt,$o),t(te,To),p(e,Va,l),p(e,nt,l),t(nt,Ao),p(e,Za,l),p(e,M,l),t(M,Dt),t(Dt,xo),t(M,qo),t(M,Ft),t(Ft,Co),t(M,zo),t(M,It),t(It,Mo),p(e,es,l),p(e,O,l),t(O,ae),t(ae,Gt),g($e,Gt,null),t(O,So),t(O,Ot),t(Ot,Po),p(e,ts,l),p(e,S,l),t(S,Lo),t(S,rt),t(rt,Do),t(S,Fo),t(S,Nt),t(Nt,Io),t(S,Go),p(e,as,l),p(e,se,l),t(se,Oo),t(se,Ht),t(Ht,No),t(se,Ho),p(e,ss,l),g(Te,e,l),p(e,os,l),p(e,oe,l),t(oe,Yo),t(oe,Yt),t(Yt,Wo),t(oe,Bo),p(e,ns,l),p(e,it,l),t(it,Uo),p(e,rs,l),p(e,N,l),t(N,ne),t(ne,Wt),g(Ae,Wt,null),t(N,Xo),t(N,Bt),t(Bt,Ro),p(e,is,l),p(e,P,l),t(P,Ko),t(P,Ut),t(Ut,Jo),t(P,Qo),t(P,Xt),t(Xt,Vo),t(P,Zo),p(e,ls,l),g(xe,e,l),p(e,ps,l),p(e,lt,l),t(lt,en),p(e,hs,l),p(e,b,l),t(b,pt),t(pt,Rt),t(Rt,tn),t(pt,an),t(b,sn),t(b,ht),t(ht,Kt),t(Kt,on),t(ht,nn),t(b,rn),t(b,re),t(re,Jt),t(Jt,ln),t(re,pn),t(re,Qt),t(Qt,hn),t(re,cn),t(b,un),t(b,ct),t(ct,Vt),t(Vt,mn),t(ct,dn),p(e,cs,l),p(e,H,l),t(H,ie),t(ie,Zt),g(qe,Zt,null),t(H,gn),t(H,ea),t(ea,fn),p(e,us,l),p(e,ut,l),t(ut,_n),p(e,ms,l),p(e,E,l),t(E,Ce),t(Ce,vn),t(Ce,mt),t(mt,yn),t(Ce,kn),t(E,wn),t(E,ta),t(ta,bn),t(E,En),t(E,Y),t(Y,jn),t(Y,dt),t(dt,$n),t(Y,Tn),t(Y,aa),t(aa,An),t(Y,xn),t(E,qn),t(E,W),t(W,Cn),t(W,sa),t(sa,zn),t(W,Mn),t(W,oa),t(oa,Sn),t(W,Pn),p(e,ds,l),g(ze,e,l),p(e,gs,l),p(e,j,l),t(j,Ln),t(j,na),t(na,Dn),t(j,Fn),t(j,gt),t(gt,In),t(j,Gn),t(j,ft),t(ft,On),t(j,Nn),p(e,fs,l),g(Me,e,l),p(e,_s,l),p(e,B,l),t(B,le),t(le,ra),g(Se,ra,null),t(B,Hn),t(B,ia),t(ia,Yn),p(e,vs,l),p(e,y,l),t(y,Wn),t(y,la),t(la,Bn),t(y,Un),t(y,pa),t(pa,Xn),t(y,Rn),t(y,ha),t(ha,Kn),t(y,Jn),t(y,ca),t(ca,Qn),t(y,Vn),t(y,ua),t(ua,Zn),t(y,er),t(y,ma),t(ma,tr),t(y,ar),t(y,da),t(da,sr),t(y,or),p(e,ys,l),p(e,L,l),t(L,nr),t(L,_t),t(_t,rr),t(L,ir),t(L,ga),t(ga,lr),t(L,pr),p(e,ks,l),g(Pe,e,l),p(e,ws,l),p(e,U,l),t(U,pe),t(pe,fa),g(Le,fa,null),t(U,hr),t(U,_a),t(_a,cr),p(e,bs,l),p(e,$,l),t($,ur),t($,va),t(va,mr),t($,dr),t($,ya),t(ya,gr),t($,fr),t($,De),t(De,_r),t($,vr),p(e,Es,l),p(e,vt,l),t(vt,yr),p(e,js,l),p(e,X,l),t(X,he),t(he,ka),g(Fe,ka,null),t(X,kr),t(X,wa),t(wa,wr),p(e,$s,l),p(e,q,l),t(q,ba),t(ba,br),t(q,Er),t(q,Ea),t(Ea,jr),t(q,$r),t(q,ja),t(ja,Tr),t(q,Ar),p(e,Ts,l),g(Ie,e,l),p(e,As,l),p(e,R,l),t(R,ce),t(ce,$a),g(Ge,$a,null),t(R,xr),t(R,Ta),t(Ta,qr),p(e,xs,l),p(e,w,l),t(w,Cr),t(w,Oe),t(Oe,zr),t(w,Mr),t(w,Ne),t(Ne,Sr),t(w,Pr),t(w,Aa),t(Aa,Lr),t(w,Dr),t(w,xa),t(xa,Fr),t(w,Ir),p(e,qs,l),g(He,e,l),p(e,Cs,l),p(e,K,l),t(K,ue),t(ue,qa),g(Ye,qa,null),t(K,Gr),t(K,Ca),t(Ca,Or),p(e,zs,l),p(e,yt,l),t(yt,Nr),p(e,Ms,l),p(e,me,l),t(me,Hr),t(me,za),t(za,Yr),t(me,Wr),p(e,Ss,l),g(We,e,l),p(e,Ps,l),p(e,J,l),t(J,de),t(de,Ma),g(Be,Ma,null),t(J,Br),t(J,Sa),t(Sa,Ur),p(e,Ls,l),p(e,kt,l),t(kt,Xr),p(e,Ds,l),p(e,ge,l),t(ge,Rr),t(ge,Pa),t(Pa,Kr),t(ge,Jr),p(e,Fs,l),g(Ue,e,l),p(e,Is,l),p(e,Q,l),t(Q,fe),t(fe,La),g(Xe,La,null),t(Q,Qr),t(Q,Da),t(Da,Vr),p(e,Gs,l),p(e,D,l),t(D,Zr),t(D,Fa),t(Fa,ei),t(D,ti),t(D,Ia),t(Ia,ai),t(D,si),p(e,Os,l),g(Re,e,l),p(e,Ns,l),p(e,V,l),t(V,_e),t(_e,Ga),g(Ke,Ga,null),t(V,oi),t(V,Oa),t(Oa,ni),p(e,Hs,l),p(e,T,l),t(T,ri),t(T,Je),t(Je,ii),t(T,li),t(T,Na),t(Na,pi),t(T,hi),t(T,Ha),t(Ha,ci),t(T,ui),p(e,Ys,l),g(Qe,e,l),p(e,Ws,l),p(e,A,l),t(A,mi),t(A,Ya),t(Ya,di),t(A,gi),t(A,Wa),t(Wa,fi),t(A,_i),t(A,wt),t(wt,vi),t(A,yi),Bs=!0},p:$p,i(e){Bs||(f(je.$$.fragment,e),f($e.$$.fragment,e),f(Te.$$.fragment,e),f(Ae.$$.fragment,e),f(xe.$$.fragment,e),f(qe.$$.fragment,e),f(ze.$$.fragment,e),f(Me.$$.fragment,e),f(Se.$$.fragment,e),f(Pe.$$.fragment,e),f(Le.$$.fragment,e),f(Fe.$$.fragment,e),f(Ie.$$.fragment,e),f(Ge.$$.fragment,e),f(He.$$.fragment,e),f(Ye.$$.fragment,e),f(We.$$.fragment,e),f(Be.$$.fragment,e),f(Ue.$$.fragment,e),f(Xe.$$.fragment,e),f(Re.$$.fragment,e),f(Ke.$$.fragment,e),f(Qe.$$.fragment,e),Bs=!0)},o(e){_(je.$$.fragment,e),_($e.$$.fragment,e),_(Te.$$.fragment,e),_(Ae.$$.fragment,e),_(xe.$$.fragment,e),_(qe.$$.fragment,e),_(ze.$$.fragment,e),_(Me.$$.fragment,e),_(Se.$$.fragment,e),_(Pe.$$.fragment,e),_(Le.$$.fragment,e),_(Fe.$$.fragment,e),_(Ie.$$.fragment,e),_(Ge.$$.fragment,e),_(He.$$.fragment,e),_(Ye.$$.fragment,e),_(We.$$.fragment,e),_(Be.$$.fragment,e),_(Ue.$$.fragment,e),_(Xe.$$.fragment,e),_(Re.$$.fragment,e),_(Ke.$$.fragment,e),_(Qe.$$.fragment,e),Bs=!1},d(e){a(I),e&&a(Ua),e&&a(G),v(je),e&&a(Xa),e&&a(Ze),e&&a(Ra),e&&a(ee),e&&a(Ka),e&&a(z),e&&a(Ja),e&&a(ot),e&&a(Qa),e&&a(te),e&&a(Va),e&&a(nt),e&&a(Za),e&&a(M),e&&a(es),e&&a(O),v($e),e&&a(ts),e&&a(S),e&&a(as),e&&a(se),e&&a(ss),v(Te,e),e&&a(os),e&&a(oe),e&&a(ns),e&&a(it),e&&a(rs),e&&a(N),v(Ae),e&&a(is),e&&a(P),e&&a(ls),v(xe,e),e&&a(ps),e&&a(lt),e&&a(hs),e&&a(b),e&&a(cs),e&&a(H),v(qe),e&&a(us),e&&a(ut),e&&a(ms),e&&a(E),e&&a(ds),v(ze,e),e&&a(gs),e&&a(j),e&&a(fs),v(Me,e),e&&a(_s),e&&a(B),v(Se),e&&a(vs),e&&a(y),e&&a(ys),e&&a(L),e&&a(ks),v(Pe,e),e&&a(ws),e&&a(U),v(Le),e&&a(bs),e&&a($),e&&a(Es),e&&a(vt),e&&a(js),e&&a(X),v(Fe),e&&a($s),e&&a(q),e&&a(Ts),v(Ie,e),e&&a(As),e&&a(R),v(Ge),e&&a(xs),e&&a(w),e&&a(qs),v(He,e),e&&a(Cs),e&&a(K),v(Ye),e&&a(zs),e&&a(yt),e&&a(Ms),e&&a(me),e&&a(Ss),v(We,e),e&&a(Ps),e&&a(J),v(Be),e&&a(Ls),e&&a(kt),e&&a(Ds),e&&a(ge),e&&a(Fs),v(Ue,e),e&&a(Is),e&&a(Q),v(Xe),e&&a(Gs),e&&a(D),e&&a(Os),v(Re,e),e&&a(Ns),e&&a(V),v(Ke),e&&a(Hs),e&&a(T),e&&a(Ys),v(Qe,e),e&&a(Ws),e&&a(A)}}}const xp={local:"text-generation-strategies",sections:[{local:"default-text-generation-configuration",title:"Default text generation configuration"},{local:"customize-text-generation",title:"Customize text generation"},{local:"save-a-custom-decoding-strategy-with-your-model",title:"Save a custom decoding strategy with your model"},{local:"streaming",title:"Streaming"},{local:"decoding-strategies",sections:[{local:"greedy-search",title:"Greedy Search"},{local:"contrastive-search",title:"Contrastive search"},{local:"multinomial-sampling",title:"Multinomial sampling"},{local:"beamsearch-decoding",title:"Beam-search decoding"},{local:"beamsearch-multinomial-sampling",title:"Beam-search multinomial sampling"},{local:"diverse-beam-search-decoding",title:"Diverse beam search decoding"}],title:"Decoding strategies"}],title:"Text generation strategies"};function qp(Ei){return Tp(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Sp extends wp{constructor(I){super();bp(this,I,qp,Ap,Ep,{})}}export{Sp as default,xp as metadata};
